"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = MenuButton;

var _react = _interopRequireWildcard(require("react"));

var _StyledMenuButton = _interopRequireDefault(require("./src/StyledMenuButton"));

var _reactjsRipple = _interopRequireDefault(require("reactjs-ripple"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function MenuButton(_ref) {
  var color = _ref.color,
      colorHover = _ref.colorHover,
      size = _ref.size,
      _ref$effect = _ref.effect,
      effect = _ref$effect === void 0 ? "cross" : _ref$effect,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? undefined : _ref$onClick,
      _ref$open = _ref.open,
      open = _ref$open === void 0 ? undefined : _ref$open,
      _ref$rippleOff = _ref.rippleOff,
      rippleOff = _ref$rippleOff === void 0 ? undefined : _ref$rippleOff;
  var timeOut = null; // Refs

  var container = (0, _react.useRef)(null);
  var span0 = (0, _react.useRef)(null);
  var span1 = (0, _react.useRef)(null);
  var span2 = (0, _react.useRef)(null);
  var span3 = (0, _react.useRef)(null); // Animate spans

  var animate = function animate() {
    clearTimeout(timeOut);

    switch (effect) {
      // Efecto de cruce
      case "cross":
        if (isOpen) {
          span0.current.style = "left: 50%; width: 0px;";
          span1.current.style = "transform: rotate(45deg);";
          span2.current.style = "transform: rotate(-45deg);";
          span3.current.style = "left: 50%; width: 0px";
        } else {
          span0.current.removeAttribute("style");
          span1.current.removeAttribute("style");
          span2.current.removeAttribute("style");
          span3.current.removeAttribute("style");
        }

        break;
      // Efecto de aleado

      case "wink":
        if (isOpen) {
          span0.current.style = "top: 48%; transform: rotate(45deg);";
          span1.current.style = "width: 0px;";
          span2.current.style = "width: 0px; left: 80%;";
          span3.current.style = "top: 48%; transform: rotate(-45deg);";
        } else {
          span0.current.removeAttribute("style");
          span1.current.removeAttribute("style");
          span2.current.removeAttribute("style");
          span3.current.removeAttribute("style");
        }

        break;
      // Efecto de aleado reverso

      case "winkReverse":
        if (isOpen) {
          span0.current.style = "top: 48%; transform: rotate(-45deg);";
          span1.current.style = "width: 0px;";
          span2.current.style = "width: 0px; left: 80%;";
          span3.current.style = "top: 48%; transform: rotate(45deg);";
        } else {
          span0.current.removeAttribute("style");
          span1.current.removeAttribute("style");
          span2.current.removeAttribute("style");
          span3.current.removeAttribute("style");
        }

        break;
      // Efecto de rebote

      case "bounce":
        if (isOpen) {
          span0.current.style = "left: 50%; width: 0px;";
          span1.current.style = "transition: all 1s; transform: rotate(225deg);";
          span2.current.style = "transition: all 1s; transform: rotate(-225deg);";
          span3.current.style = "left: 50%; width: 0px;";
        } else {
          span1.current.style = "transition: all 1s; transform: rotate(0deg);";
          span2.current.style = "transition: all 1s; transform: rotate(0deg);";
          timeOut = setTimeout(function () {
            span0.current.removeAttribute("style");
            span1.current.removeAttribute("style");
            span2.current.removeAttribute("style");
            span3.current.removeAttribute("style");
          }, 400);
        }

        break;
      // Efecto de rotación

      case "rotate":
        if (isOpen) {
          container.current.style = "transition: all .9s; transform: rotate(360deg);";
          span0.current.style = "transition: all .8s; left: 50%; width: 0px;";
          span1.current.style = "transition: all .8s; transform: rotate(45deg);";
          span2.current.style = "transition: all .8s; transform: rotate(-45deg);";
          span3.current.style = "transition: all .8s; left: 50%; width: 0px;";
        } else {
          container.current.style = "transition: all .9s; transform: rotate(0deg);";
          span0.current.style = "transition: all .8s; left: 20%; width: 60%;";
          span1.current.style = "transition: all .8s; transform: rotate(0deg);";
          span2.current.style = "transition: all .8s; transform: rotate(0deg);";
          span3.current.style = "transition: all .8s; left: 20%; width: 60%;";
          timeOut = setTimeout(function () {
            container.current.removeAttribute("style");
            span0.current.removeAttribute("style");
            span1.current.removeAttribute("style");
            span2.current.removeAttribute("style");
            span3.current.removeAttribute("style");
          }, 800);
        }

        break;
      // Efecto de rotación inverso

      case "rotateReverse":
        if (isOpen) {
          container.current.style = "transition: all .9s; transform: rotate(-360deg);";
          span0.current.style = "transition: all .8s; left: 50%; width: 0px;";
          span1.current.style = "transition: all .8s; transform: rotate(45deg);";
          span2.current.style = "transition: all .8s; transform: rotate(-45deg);";
          span3.current.style = "transition: all .8s; left: 50%; width: 0px;";
        } else {
          container.current.style = "transition: all .9s; transform: rotate(0deg);";
          span0.current.style = "transition: all .8s; left: 20%; width: 60%;";
          span1.current.style = "transition: all .8s; transform: rotate(0deg);";
          span2.current.style = "transition: all .8s; transform: rotate(0deg);";
          span3.current.style = "transition: all .8s; left: 20%; width: 60%;";
          timeOut = setTimeout(function () {
            container.current.removeAttribute("style");
            span0.current.removeAttribute("style");
            span1.current.removeAttribute("style");
            span2.current.removeAttribute("style");
            span3.current.removeAttribute("style");
          }, 800);
        }

        break;
      // Efecto de empuje

      case "push":
        if (isOpen) {
          span0.current.style = "transition: .6s; left: 80%; width: 0px;";
          span1.current.style = "transition: .6s; transform: rotate(45deg);";
          span2.current.style = "transition: .6s; transform: rotate(135deg);";
          span3.current.style = "transition: .6s; left: 20%; width: 0px;";
        } else {
          span0.current.style = "transition: all .6s; left: 20%; width: 60%;";
          span1.current.style = "transition: all .6s; transform: rotate(0deg);";
          span2.current.style = "transition: all .6s; transform: rotate(0deg);";
          span3.current.style = "transition: all .6s; left: 20%; width: 60%;";
          timeOut = setTimeout(function () {
            span0.current.removeAttribute("style");
            span1.current.removeAttribute("style");
            span2.current.removeAttribute("style");
            span3.current.removeAttribute("style");
          }, 800);
        }

        break;
      // Efecto de empuje inverso

      case "pushReverse":
        if (isOpen) {
          span0.current.style = "transition: .6s; left: 20%; width: 0px;";
          span1.current.style = "transition: .6s; transform: rotate(-45deg);";
          span2.current.style = "transition: .6s; transform: rotate(-135deg);";
          span3.current.style = "transition: .6s; left: 80%; width: 0px;";
        } else {
          span0.current.style = "transition: all .6s; left: 20%; width: 60%;";
          span1.current.style = "transition: all .6s; transform: rotate(0deg);";
          span2.current.style = "transition: all .6s; transform: rotate(0deg);";
          span3.current.style = "transition: all .6s; left: 20%; width: 60%;";
          timeOut = setTimeout(function () {
            span0.current.removeAttribute("style");
            span1.current.removeAttribute("style");
            span2.current.removeAttribute("style");
            span3.current.removeAttribute("style");
          }, 800);
        }

        break;
      // Efecto asíncrono

      case "async":
        if (isOpen) {
          timeOut = setTimeout(function () {
            span0.current.style = "top: 48%; transform: rotate(-225deg);";
          }, 200);
          span1.current.style = "width: 0px;";
          span2.current.style = "width: 0px; left: 80%";
          span3.current.style = "top: 48%; transform: rotate(225deg);";
        } else {
          span0.current.removeAttribute("style");
          span1.current.removeAttribute("style");
          span2.current.removeAttribute("style");
          timeOut = setTimeout(function () {
            span3.current.removeAttribute("style");
          }, 200);
        }

        break;
      // Efecto asíncrono inverso

      case "asyncReverse":
        if (isOpen) {
          span0.current.style = "top: 48%; transform: rotate(225deg);";
          span1.current.style = "width: 0px;";
          span2.current.style = "width: 0px; left: 80%";
          timeOut = setTimeout(function () {
            span3.current.style = "top: 48%; transform: rotate(-225deg);";
          }, 200);
        } else {
          timeOut = setTimeout(function () {
            span0.current.removeAttribute("style");
          }, 200);
          span1.current.removeAttribute("style");
          span2.current.removeAttribute("style");
          span3.current.removeAttribute("style");
        }

        break;
      // Efecto spin

      case "spin":
        if (isOpen) {
          container.current.style = "transition: all .5s; transform: rotate(90deg);";
          span1.current.style = "width: 0px;";
          span2.current.style = "width: 0px; left: 80%;";
          timeOut = setTimeout(function () {
            span0.current.style = "top: 48%; transform: rotate(45deg);";
            span3.current.style = "top: 48%; transform: rotate(135deg);";
          }, 200);
        } else {
          container.current.style = "transition: all .5s; transform: rotate(0deg);";
          span0.current.removeAttribute("style");
          span3.current.removeAttribute("style");
          timeOut = setTimeout(function () {
            span1.current.removeAttribute("style");
            span2.current.removeAttribute("style");
            container.current.removeAttribute("style");
          }, 200);
        }

        break;
      // Efecto spin inverso

      case "spinReverse":
        if (isOpen) {
          container.current.style = "transition: all .5s; transform: rotate(-90deg);";
          span1.current.style = "width: 0px;";
          span2.current.style = "width: 0px; left: 80%;";
          timeOut = setTimeout(function () {
            span0.current.style = "top: 48%; transform: rotate(-45deg);";
            span3.current.style = "top: 48%; transform: rotate(-135deg);";
          }, 200);
        } else {
          container.current.style = "transition: all .5s; transform: rotate(0deg);";
          span0.current.removeAttribute("style");
          span3.current.removeAttribute("style");
          timeOut = setTimeout(function () {
            span1.current.removeAttribute("style");
            span2.current.removeAttribute("style");
            container.current.removeAttribute("style");
          }, 200);
        }

        break;
    }
  }; // Handle click on element


  var handleClick = function handleClick(ev) {
    if (typeof onClick === "function") {
      setIsOpen(!isOpen);
    } else if (onClick === undefined && open === undefined) {
      console.error("[MenuButton]: <MenuButton /> need 'open' or 'onClick' properties");
    } else if (onClick !== undefined && typeof onClick !== "function") {
      console.error("[MenuButton]: 'onClick' param must be a function");
    } else if (open !== undefined && typeof open !== "boolean") {
      console.error("[MenuButton]: 'open' property must be a boolean");
    }
  }; // Handle isOpen


  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isOpen = _useState2[0],
      setIsOpen = _useState2[1];

  (0, _react.useEffect)(function () {
    if (!initialized) {
      return;
    }

    animate();

    if (typeof onClick === "function") {
      onClick({
        isOpen: isOpen
      });
    }
  }, [isOpen]); // Handle open

  (0, _react.useEffect)(function () {
    if (typeof open !== "boolean") {
      return;
    }

    setIsOpen(open);
  }, [open]); // Handle intialized

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      initialized = _useState4[0],
      setInitialized = _useState4[1];

  (0, _react.useEffect)(function () {
    setInitialized(true);
  }, []);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_StyledMenuButton.default, {
    ref: container,
    color: color,
    colorHover: colorHover,
    size: size
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "spans",
    onClick: handleClick
  }, /*#__PURE__*/_react.default.createElement("span", {
    ref: span0
  }), /*#__PURE__*/_react.default.createElement("span", {
    ref: span1
  }), /*#__PURE__*/_react.default.createElement("span", {
    ref: span2
  }), /*#__PURE__*/_react.default.createElement("span", {
    ref: span3
  }), !rippleOff && /*#__PURE__*/_react.default.createElement(_reactjsRipple.default, null))));
}